/*
 * Copyright © 2012 Faidon Liambotis <paravoid@debian.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Alternatively, you can redistribute and/or modify this program under the
 * same terms that the “gnome-shell” or “gnome-shell-extensions” software
 * packages are being distributed by The GNOME Project.
 *
 */

const Lang = imports.lang;
const Shell = imports.gi.Shell;
const WindowAttentionHandler = imports.ui.windowAttentionHandler;

const WindowUrgentHandler = new Lang.Class({
	Name: 'WindowUrgentHandler',
	Extends: WindowAttentionHandler.WindowAttentionHandler,

    _init : function() {
        this._tracker = Shell.WindowTracker.get_default();
        this.signalID = global.display.connect('window-marked-urgent',
			Lang.bind(this, this._onWindowDemandsAttention));
    },

    _getTitleAndBanner: function(app, window) {
        let title = app.get_name();
        let banner = _("'%s' requires your attention").format(window.get_title());
        return [title, banner]
    },

    destroy : function() {
       if (this.signalID) {
           global.display.disconnect(this.signalID);
       }
    }
});

function init(meta) {
    // empty
}

let windowUrgentHandler;

function enable() {
    windowUrgentHandler = new WindowUrgentHandler();
}

function disable() {
    windowUrgentHandler.destroy();
}
